import jp.jig.jiglet.*;

public class RSSTicker extends Jiglet {
	private static final int DRAW_STATE_MAIN = 0;
	private static final int DRAW_STATE_CONFIG = 1;
	
	String tickString = null;
	String[] urlList;
	String[] idList;
	int[] wList;
	int scrollX;
	int tickWidth;
	boolean allRepaint = true;
	int drawState = DRAW_STATE_MAIN;
	
	public void main() {
		clearKey();
		setMenu(new String[] { "ݒ" }, new String[] { "RSSTicker̐ݒ܂B" });
		// RSS
		makeTicker();
		scrollX = DW;
		tickWidth = stringWidth(tickString);
		
		setSoftLabel("XV");
		allRepaint = true;
		repaint();
		
		int searchHead = 1;
		int len = wList.length;
		int center = DW / 2;
		for (;;) {
			int key = getKey();
			if (key == KEY_SOFT) {
				// XV
				updateRSS();
				makeTicker();
				scrollX = DW;
				tickWidth = stringWidth(tickString);
				clearKey();
				searchHead = 1;
				allRepaint = true;
			} else if (key == KEY_SELECT) {
				// LI
				if (idList[searchHead] != null) {
					setRSSItemFlag(idList[searchHead], false);
					flushRSS();
					//launch(urlList[searchHead], ENCODE_SJIS, LAUNCH_KEEP_ALIVE);
					launch(urlList[searchHead], ENCODE_SJIS, LAUNCH_TERMINATE);
				}
				/*
				println("select : searchHead = " + searchHead);
				for (int i = searchHead; i < len; i++) {
					if (wList[i - 1] + scrollX < center && wList[i] + scrollX > center && idList[i] != null) {
						println("select : i = " + i);
						setRSSItemFlag(idList[i], false);
						flushRSS();
						// uEUN
						launch(urlList[i], ENCODE_SJIS, LAUNCH_TERMINATE);
						break;
					}
				}
				*/
			} else if (key == KEY_IAPP) {
				// 񊈐
				setState(STATE_JIGLET, JIGLET_DEACTIVE);
			} else if (key > KEY_LAST) {
				if (key == EVENT_CLOSE) {
					// 遨sleep
					setState(STATE_JIGLET, JIGLET_SLEEP);
				} else if (key == EVENT_OPEN) {
					setState(STATE_JIGLET, JIGLET_DEACTIVE);
					allRepaint = true;
				} else if (key == EVENT_ACTIVATE) {
					allRepaint = true;
				} else if ((key & EVENT_MENU) != 0) {
					// ݒ
					//configMode();
				}
			}
			scrollX = scrollX - 10;
			if (tickWidth + scrollX <= 0) {
				scrollX = 0;
				searchHead = 1;
			}
			for (int i = searchHead; i < len; i++) {
				if (wList[i - 1] + scrollX < center && wList[i] + scrollX > center && idList[i] != null) {
					searchHead = i;
					break;
				}
			}
			
			repaint();
			sleep(300);
		}
	}
	
	// ݒ
	private void configMode() {
		drawState = DRAW_STATE_CONFIG;
		for (;;) {
			int key = getKey();
			if(key > 0) {
				break;
			}
			sleep(100);
		}
		clearKey();
		drawState = DRAW_STATE_MAIN;
		allRepaint = true;
	}
	
	private void makeTicker() {
		String[][] rssCh = getRSSChannels();
		int cnt = 0;
		for (int i = 0; i < rssCh.length; i++) {
			// I`l̂
			if ("1".equals(rssCh[i][RSS_CHANNEL_SELECTED])) {
				cnt++;
				String[][] rssItem = getRSSItems(rssCh[i][RSS_CHANNEL_ID]);
				for (int j = rssItem.length - 1; j >= 0; j--) {
					if ("1".equals(rssItem[j][RSS_ITEM_FLAG])) {
						// ǂ̂
						cnt++;
					}
				}
				rssItem = null;
			}
		}
		cnt++;
		String ticker = "";
		String today = getTodayStr();
		String[] urls = new String[cnt];
		String[] ids = new String[cnt];
		int[] wList = new int[cnt];
		String current;
		int startPos = 0;
		cnt = 1;
		for (int i = 0; i < rssCh.length; i++) {
			// I`l̂
			if (!"1".equals(rssCh[i][RSS_CHANNEL_SELECTED])) {
				continue;
			}
			current = "  " + rssCh[i][RSS_CHANNEL_TITLE] + " ";
			wList[cnt] = startPos + stringWidth(current);
			startPos = wList[cnt++];
			ticker += current;
			
			String[][] rssItem = getRSSItems(rssCh[i][RSS_CHANNEL_ID]);
			//for (int j = 2; j >= 0; j--) {
			for (int j = rssItem.length - 1; j >= 0; j--) {
				if ("1".equals(rssItem[j][RSS_ITEM_FLAG])) {
					current = "";
					// ǂ̂
					current += rssItem[j][RSS_ITEM_TITLE] + "(";
					if (today.equals(rssItem[j][RSS_ITEM_DATE])) {
						current += rssItem[j][RSS_ITEM_TIME];
					} else {
						current += rssItem[j][RSS_ITEM_DATE];
					}
					current += ")  ";
					urls[cnt] = rssItem[j][RSS_ITEM_URL];
					ids[cnt] = rssItem[j][RSS_ITEM_ID];
					wList[cnt] = startPos + stringWidth(current);
					startPos = wList[cnt++];
					ticker += current;
				}
			}
			rssItem = null;
		}
		this.tickString = ticker;
		this.urlList = urls;
		this.idList = ids;
		this.wList = wList;
		
	}
	private static String getTodayStr() {
		String today = "";
		int t = getTime(CALENDAR_MONTH) + 1;
		if (t < 10) {
			today = "0";
		}
		today += t + "/";
		t = getTime(CALENDAR_DATE);
		if (t < 10) {
			today += "0";
		}
		today += t;
		return today;
	}
	public void paint(boolean allDrawFlag) {
		setFont(0);
		if (drawState == DRAW_STATE_MAIN) {
			// C(H)
			setColor(0, 0, 0);
			if (allRepaint || allDrawFlag) {
				fillRect(0, 0, DW, DH);
				Image bk = getConciergeImage();
				int x = (DW - bk.getWidth()) / 2;
				int y = (DH - bk.getHeight()) / 2;
				drawImage(bk, x, y);
				allRepaint = false;
			}
			int h = 4 + getFontHeight();
			fillRect(0, DH - h, DW, h);
			setColor(255, 255, 255);
			if (tickString != null) {
				drawString(tickString, scrollX, DH - 2);
				if (scrollX + tickWidth < DW) {
					drawString(tickString, scrollX + tickWidth, DH - 2);
				}
			}
		} else if (drawState == DRAW_STATE_CONFIG) {
			// ݒ
			setColor(192, 192, 192);
			fillRect(20, 20, DW - 40, DH - 40);
			draw3DButton(20, 20, DW - 40, DH - 40);
			setColor(0, 0, 0);
			drawString("ݒ", 22, 22 + getFontHeight());
		}
	}
}
